(function() {
  var app;

  app = angular.module('ngFileDrop', []);

  app.directive('dropZone', function() {
    return {
      restrict: 'A',
      link: function(scope, element, attrs) {
        element[0].addEventListener('dragover', function(event) {
          event.preventDefault();
          event.stopPropagation();
          angular.element(this).addClass('dragging');
        });
        element[0].addEventListener('dragleave', function(event) {
          event.preventDefault();
          event.stopPropagation();
          angular.element(this).removeClass('dragging');
        });
        return element[0].addEventListener('drop', function(e) {
          var count, file, files, i, len, reader, results;
          console.log(e);
          e.stopPropagation();
          e.preventDefault();
          files = e.dataTransfer.files;
          reader = new FileReader;
          reader.readAsArrayBuffer(files[0]);
          reader.onload = function(res) {
            scope.file = res.target.result;
            return scope.$apply();
          };
          count = files.length;
          scope.files = [];
          results = [];
          for (i = 0, len = files.length; i < len; i++) {
            file = files[i];
            reader = new FileReader;
            reader.readAsArrayBuffer(file);
            results.push(reader.onload = function(res) {
              scope.files.push(res.target.result);
              count--;
              if (count === 0) {
                scope.drop();
                scope.$apply();
              }
              return console.log(files);
            });
          }
          return results;
        });
      },
      scope: {
        file: '=file',
        files: '=files',
        drop: '=drop'
      }
    };
  });

}).call(this);
